//**********************************************************************
//   Copyright (C) 2009 Dwayne Forsyth
//                                 
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published 0by the Free Software Foundation; either version 2
//   of the License, or (at your option) any later version.
// 
//   This program is distributed in the hope that it will 0be useful,
//   0but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
// 
//      Free Software Foundation, Inc.
//      51 Franklin Street, Fifth Floor
//      Boston, MA  02110-1301, USA.
//
//**********************************************************************
// DF1 - test planes
//**********************************************************************
#include "system_config.h"
#include "ascii_table.h"

const  uint8_t pattern0[] = {
     0x07,0x20,
//--- Frame 1,
     0b00000000, // x=000, y=000, a=0, set all LEDs off

     0b00100011, // x=001, y=000, a=1, shift down, fill 1, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b00100001, // x=001, y=000, a=0, shift down, eof

     0b01100011, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof

     0b01100001, // x=003, y=000, a=1, shift right, eof
};

//**********************************************************************
// Fader test
//**********************************************************************
const  uint8_t pattern1[] = {
     0x06,0x17,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b11111000,
     0b11110000,
     0b11100000,
     0b11000000,
     0b10000000,
};
#ifndef MEMLIGHT
//**********************************************************************
// Pong
//**********************************************************************

const  uint8_t pattern2[] = {
     0x07,0x70,
//1
     0b00000000, // x=000, y=000, a=0, set all LEDs off
     0b11111110, // 7,7 = 1  paddle
     0b11111010, // 7,6 = 1
     0b11110110, // 7,5 = 1
     0b10111100, // 5,5 = 0 remove old ball
     0b11011010, // 6,6 = 1   ball
     0b00010110, // 0,5 = 1   paddle
     0b00010010, // 0,4 = 1
     0b00001111, // 0,3 = 1, eof
//2
     0b11011000, // 6,6 = 0 remove old ball
     0b10111111, // 5,7 = 1, eof  new ball
//3
     0b10111100, // 5,7 = 0 remove old ball
     0b10011011, // 4,6 = 1, eof  new ball
//4
     0b00010100, // 0,5 = 0 left paddle down
     0b00001010, // 0,2 = 1
     0b10011000, // 4,6 = 0 remove old ball
     0b01110111, // 3,5 = 1, eof  new ball
//5
     0b01110100, // 3,5 = 0 remove old ball
     0b01010011, // 2,4 = 1, eof  new ball
//6
     0b01010000, // 2,4 = 0 remove old ball
     0b00101111, // 1,3 = 1, eof  new ball
//7
     0b00101100, // 1,3 = 0 remove old ball
     0b01001011, // 2,2 = 1, eof  new ball
//8
     0b01001000, // 2,2 = 0 remove old ball
     0b01100111, // 3,1 = 1, eof  new ball
//9
     0b01100100, // 3,1 = 0 remove old ball
     0b10001011, // 4,2 = 1, eof  new ball
//a
     0b11111100, // 7,7 = 0 right paddle down
     0b11110010, // 7,4 = 1
     0b10001000, // 4,2 = 0 remove old ball
     0b10101111, // 5,3 = 1, eof  new ball
//b
     0b11111000, // 7,6 = 0 right paddle down
     0b11101110, // 7,3 = 1
     0b10101100, // 5,3 = 0 remove old ball
     0b11010011, // 6,4 = 1, eof  new ball
//c
     0b11010000, // 6,4 = 0 remove old ball
     0b10110111, // 5,5 = 1, eof  new ball
//d
     0b10110100, // 5,5 = 0 remove old ball
     0b10011011, // 4,6 = 1, eof  new ball
//e
     0b00010110, // 0,5 = 1 left paddle up
     0b00001000, // 0,2 = 0
     0b10011000, // 4,6 = 0 remove old ball
     0b01111111, // 3,7 = 1, eof  new ball
//f
     0b00011010, // 0,6 = 1 left paddle up
     0b00001100, // 0,3 = 0
     0b01111100, // 3,7 = 0 remove old ball
     0b01011011, // 2,6 = 1, eof  new ball
//g
     0b01011000, // 2,6 = 0 remove old ball
     0b00110111, // 1,5 = 1, eof  new ball
//h
     0b00110100, // 1,5 = 0 remove old ball
     0b01010011, // 2,4 = 1, eof  new ball
//i
     0b01010000, // 2,4 = 0 remove old ball
     0b01101111, // 3,3 = 1, eof  new ball
//j
     0b11110100, // 7,5 = 0 right paddle down
     0b11101010, // 7,2 = 1

     0b01101100, // 3,3 = 0 remove old ball
     0b10001011, // 4,2 = 1, eof  new ball
//k
     0b11110000, // 7,4 = 0 right paddle down
     0b11100110, // 7,1 = 1

     0b10001000, // 4,2 = 0 remove old ball
     0b10100111, // 5,1 = 1, eof  new ball
//l
     0b10100100, // 5,1 = 0 remove old ball
     0b11001011, // 6,2 = 1, eof  new ball
//m
     0b11001000, // 6,2 = 0 remove old ball
     0b10101111, // 5,3 = 1, eof  new ball
//n
     0b10101100, // 5,3 = 0 remove old ball
     0b10010011, // 4,4 = 1, eof  new ball
//o
     0b00011110, // 0,7 = 1 left paddle up
     0b00010000, // 0,4 = 0

     0b10010000, // 4,4 = 0 remove old ball
     0b01110111, // 3,5 = 1, eof  new ball
//p
     0b01110100, // 3,5 = 0 remove old ball
     0b01011011, // 2,6 = 1, eof  new ball
//q
     0b01011000, // 2,6 = 0 remove old ball
     0b00111111, // 1,7 = 1, eof  new ball
//p
     0b00111100, // 1,7 = 0 remove old ball
     0b01011011, // 2,6 = 1, eof  new ball
//o
     0b00010010, // 0,4 = 1 left paddle Down
     0b00011100, // 0,7 = 0

     0b01011000, // 2,6 = 0 remove old ball
     0b01110111, // 3,5 = 1, eof  new ball
//n
     0b01110100, // 3,5 = 0 remove old ball
     0b10010011, // 4,4 = 1, eof  new bal
//m
     0b10010000, // 4,4 = 0 remove old ball
     0b10101111, // 5,3 = 1, eof  new ball
//l
     0b10101100, // 5,3 = 0 remove old ball
     0b11001011, // 6,2 = 1, eof  new ball
//k
     0b11001000, // 6,2 = 0 remove old ball
     0b10100111, // 5,1 = 1, eof  new ball
//j
     0b10100100, // 5,1 = 0 remove old ball
     0b10001011, // 4,2 = 1, eof  new ball
//i
     0b10001000, // 4,2 = 0 remove old ball
     0b01101111, // 3,3 = 1, eof  new ball
//h
     0b01101100, // 3,3 = 0 remove old ball
     0b01010011, // 2,4 = 1, eof  new ball
//g
     0b01010000, // 2,4 = 0 remove old ball
     0b00110111, // 1,5 = 1, eof  new ball
//f
     0b00110100, // 1,5 = 0 remove old ball
     0b01011011, // 2,6 = 1, eof  new ball
//e
     0b11100100, // 7,1 = 0 right paddle up
     0b11110010, // 7,4 = 1

     0b01011000, // 2,6 = 0 remove old ball
     0b01111111, // 3,7 = 1, eof  new ball
//d
     0b11101000, // 7,2 = 0 right paddle up
     0b11110110, // 7,5 = 1

     0b01111100, // 3,7 = 0 remove old ball
     0b10011011, // 4,6 = 1, eof  new ball
//c
     0b10011000, // 4,6 = 0 remove old ball
     0b10110111, // 5,5 = 1, eof  new ball
//b
     0b10110100, // 5,5 = 0 remove old ball
     0b11010011, // 6,4 = 1, eof  new ball
//a
     0b11010000, // 6,4 = 0 remove old ball
     0b10101111, // 5,3 = 1, eof  new ball
//9
     0b10101100, // 5,3 = 0 remove old ball
     0b10001011, // 4,2 = 1, eof  new ball
//8
     0b10001000, // 4,2 = 0 remove old ball
     0b01100111, // 3,1 = 1, eof  new ball
//7
     0b00001110, // 0,3 = 1 left paddle Down
     0b00011000, // 0,6 = 0

     0b01100100, // 3,1 = 0 remove old ball
     0b01001011, // 2,2 = 1, eof  new ball
//6
     0b00001010, // 0,2 = 1 left paddle Down
     0b00010100, // 0,5 = 0

     0b01001000, // 2,2 = 0 remove old ball
     0b00101111, // 1,3 = 1, eof  new ball
//5
     0b00101100, // 1,3 = 0 remove old ball
     0b01010011, // 2,4 = 1, eof  new ball
//4
     0b01010000, // 2,4 = 0 remove old ball
     0b01110111, // 3,5 = 1, eof  new ball
//3
     0b11101100, // 7,3 = 0 right paddle up
     0b11111010, // 7,6 = 1

     0b01110100, // 3,5 = 0 remove old ball
     0b10011011, // 4,6 = 1, eof  new ball
//2
     0b11110000, // 7,4 = 0 right paddle up
     0b11111110, // 7,7 = 1

     0b10011000, // 4,6 = 0 remove old ball
     0b10111111, // 5,7 = 1, eof  new ball
//1
     0b10111100, // 5,7 = 0 remove old ball
     0b11011011, // 6,6 = 1, eof  new ball
//v
     0b11011000, // 6,6 = 0 remove old ball
     0b10110111, // 5,5 = 1, eof  new ball
//w
     0b10110100, // 5,5 = 0 remove old ball
     0b10010011, // 4,4 = 1, eof  new ball
//x
     0b00000110, // 0,1 = 1 left paddle Down
     0b00010000, // 0,4 = 0

     0b10010000, // 4,4 = 0 remove old ball
     0b01101111, // 3,3 = 1, eof  new ball
//y

     0b01101100, // 3,3 = 0 remove old ball
     0b01001011, // 2,2 = 1, eof  new ball
//z
     0b01001000, // 2,2 = 0 remove old ball
     0b00100111, // 1,1 = 1, eof  new ball
//y
     0b00100100, // 1,1 = 0 remove old ball
     0b01001011, // 2,2 = 1, eof  new ball
//x
     0b01001000, // 2,2 = 0 remove old ball
     0b01101111, // 3,3 = 1, eof  new ball
//w
     0b01101100, // 3,3 = 0 remove old ball
     0b10010011, // 4,4 = 1, eof  new ball
//v
     0b10010000, // 4,4 = 0 remove old ball
     0b10110111, // 5,5 = 1, eof  new ball

};


//**********************************************************************
// Fader test
//**********************************************************************
const  uint8_t pattern3[] = {
     0x06,0x20,
//--- Frame 1,
     0b00000010,
     0b00000110,
     0b00001110,
     0b00011110,
     0b00111110,
     0b01111110,
     0b11111110,
     0b01111110,
     0b00111110,
     0b00011110,
     0b00001110,
     0b00000110,
     0b00000010,
     0b00000000,

};

//**********************************************************************
// half sync fading
//**********************************************************************
const  uint8_t pattern4[] = {
     0x08,0x06,
//--- Frame 1,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
//--- Frame 1,
     0b01000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
//--- Frame 1,
     0b00100000,
     0b01000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
  //--- Frame 1,
     0b00010000,
     0b00100000,
     0b01000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
//--- Frame 1,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000111,
//--- Frame 1,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000111,
//--- Frame 1,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b10000000,
     0b00000000,
     0b00000111,
//--- Frame 1,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b10000000,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b01000000,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00100000,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00010000,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00001000,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000100,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000010,
     0b00000111,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000111,
};

//**********************************************************************
// fast flash
//**********************************************************************
const uint8_t pattern5[] =
     "\x03\x04"
     "  I went to Musecon\'s workshop room and built this cool blinkie ";


//**********************************************************************
//  so many blinkies, so little time
//**********************************************************************

const char pattern6[] =
       "\x03\x03"
       "  so many blinkies, so little time. ";

//**********************************************************************
//  www.2dkits.com
//**********************************************************************

const char pattern7[] =
       "\x03\x05"
       "  www.2dkits.com";

//**********************************************************************
//  www.2dkits.com
//**********************************************************************

const char pattern8[] =
       "\x03\x04"
       "  Musecon 4  August 1-3 2014";

//**********************************************************************
// random fader
//**********************************************************************

const  uint8_t pattern9[] = {
     0x09,0x10,
//--- Frame 1,
     0b00000111,
};
const uint8_t pattern10[] = {
     0x08,0x02,
//--- Frame 1,
     0b11111000,
     0b11110000,
     0b11100000,
     0b11000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000011,
//--- Frame 1,
     0b01111100,
     0b11111000,
     0b11110000,
     0b11100000,
     0b11000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000011,
//--- Frame 1,
     0b00111110,
     0b01111100,
     0b11111000,
     0b11110000,
     0b11100000,
     0b11000000,
     0b10000000,
     0b00000000,
     0b00000011,
//--- Frame 1,
     0b00011111,
     0b00111110,
     0b01111100,
     0b11111000,
     0b11110000,
     0b11100000,
     0b11000000,
     0b10000000,
     0b00000011,
//--- Frame 1,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b11111000,
     0b11110000,
     0b11100000,
     0b11000000,
     0b00000011,
//--- Frame 1,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b11111000,
     0b11110000,
     0b11100000,
     0b00000011,
//--- Frame 1,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b11111000,
     0b11110000,
     0b00000011,
//--- Frame 1,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b11111000,
     0b00000011,
//--- Frame 1,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b01111100,
     0b00000011,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00111110,
     0b00000011,
//--- Frame 1,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00011111,
     0b00000011,
//--- Frame 1,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00001111,
     0b00000011,
//--- Frame 1,
     0b11000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000111,
     0b00000011,
//--- Frame 1,
     0b11100000,
     0b11000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
     0b00000011,
//--- Frame 1,
     0b11110000,
     0b11100000,
     0b11000000,
     0b10000000,
     0b00000000,
     0b00000000,
     0b00000000,
     0b00000001,
     0b00000011,
};
#endif
//**********************************************************************
// Char tables
//**********************************************************************


const struct s chardata[] = {
   { 0x01, { 0x00, 0x00, 0x00, 0x00, 0x00 }}, // 0x20 space
   { 0x01, { 0xF2, 0x00, 0x00, 0x00, 0x00 }}, // 0x21 !
   { 0x03, { 0xE0, 0x00, 0xE0, 0x00, 0x00 }}, // 0x22 "
   { 0x05, { 0x28, 0xFE, 0x28, 0xFE, 0x28 }}, // 0x23 #
#ifndef MEMLIGHT
   {{ 0x05 }, { 0x24, 0x54, 0xFE, 0x54, 0x48 }}, // 0x24 $
   {{ 0x05 }, { 0xC4, 0xC8, 0x10, 0x26, 0x46 }}, // 0x25%
   {{ 0x05 }, { 0x6C, 0x92, 0xAA, 0x84, 0x0A }}, // 0x26 &
   {{ 0x02 }, { 0xA0, 0xC0, 0x00, 0x00, 0x00 }}, // 0x27 '
   {{ 0x03 }, { 0x38, 0x44, 0x82, 0x00, 0x00 }}, // 0x28 (
   {{ 0x03 }, { 0x82, 0x44, 0x38, 0x00, 0x00 }}, // 0x29 )
   {{ 0x05 }, { 0x28, 0x10, 0x7C, 0x10, 0x28 }}, // 0x2A *
   {{ 0x05 }, { 0x10, 0x10, 0x7C, 0x10, 0x10 }}, // 0x2B +
   {{ 0x02 }, { 0x05, 0x06, 0x00, 0x00, 0x00 }}, // 0x2C ,
   {{ 0x05 }, { 0x10, 0x10, 0x10, 0x10, 0x10 }}, // 0x2D -
   {{ 0x02 }, { 0x06, 0x06, 0x00, 0x00, 0x00 }}, // 0x2E .
   {{ 0x05 }, { 0x04, 0x08, 0x10, 0x20, 0x40 }}, // 0x2F /
   {{ 0x04 }, { 0x7C, 0x82, 0x82, 0x7C, 0x00 }}, // 0x30 0
   {{ 0x03 }, { 0x42, 0xFE, 0x02, 0x00, 0x00 }}, // 0x31 1
   {{ 0x04 }, { 0x46, 0x8A, 0x92, 0x62, 0x00 }}, // 0x32 2
   {{ 0x04 }, { 0x44, 0x82, 0x92, 0x6C, 0x00 }}, // 0x33 3
   {{ 0x05 }, { 0x18, 0x28, 0x48, 0xFE, 0x08 }}, // 0x34 4
   {{ 0x04 }, { 0xE4, 0xA2, 0xA2, 0x9C, 0x00 }}, // 0x35 5
   {{ 0x04 }, { 0x3C, 0x52, 0x92, 0x0C, 0x00 }}, // 0x36 6
   {{ 0x04 }, { 0x80, 0x8E, 0x90, 0xE0, 0x00 }}, // 0x37 7
   {{ 0x04 }, { 0x6C, 0x92, 0x92, 0x6C, 0x00 }}, // 0x38 8
   {{ 0x04 }, { 0x60, 0x92, 0x92, 0x7C, 0x00 }}, // 0x39 9
   {{ 0x02 }, { 0x36, 0x36, 0x00, 0x00, 0x00 }}, // 0x3A :
   {{ 0x02 }, { 0x35, 0x36, 0x00, 0x00, 0x00 }}, // 0x3B ;
   {{ 0x04 }, { 0x10, 0x28, 0x44, 0x82, 0x00 }}, // 0x3C <
   {{ 0x05 }, { 0x28, 0x28, 0x28, 0x28, 0x28 }}, // 0x3D =
   {{ 0x04 }, { 0x82, 0x44, 0x28, 0x10, 0x00 }}, // 0x3E >
   {{ 0x05 }, { 0x40, 0x80, 0x8A, 0x90, 0x60 }}, // 0x3F ?
   {{ 0x05 }, { 0x4C, 0x92, 0x9E, 0x82, 0x7C }}, // 0x40 @
   {{ 0x05 }, { 0x3E, 0x48, 0x88, 0x48, 0x3E }}, // 0x41 A
   {{ 0x05 }, { 0xFE, 0x92, 0x92, 0x92, 0x6C }}, // 0x42 B
   {{ 0x05 }, { 0x7C, 0x82, 0x82, 0x82, 0x44 }}, // 0x43 C
   {{ 0x05 }, { 0xFE, 0x82, 0x82, 0x82, 0x7C }}, // 0x44 D
   {{ 0x05 }, { 0xFE, 0x92, 0x92, 0x92, 0x92 }}, // 0x45 E
   {{ 0x05 }, { 0xFE, 0x90, 0x90, 0x90, 0x90 }}, // 0x46 F
   {{ 0x05 }, { 0x7C, 0x82, 0x92, 0x92, 0x5C }}, // 0x47 G
   {{ 0x05 }, { 0xFE, 0x10, 0x10, 0x10, 0xFE }}, // 0x48 H
   {{ 0x03 }, { 0x82, 0xFE, 0x82, 0x00, 0x00 }}, // 0x49 I
   {{ 0x04 }, { 0x04, 0x02, 0x02, 0xFC, 0x00 }}, // 0x4A J
   {{ 0x05 }, { 0xFE, 0x10, 0x28, 0x44, 0x82 }}, // 0x4B K
   {{ 0x05 }, { 0xFE, 0x02, 0x02, 0x02, 0x02 }}, // 0x4C L
   {{ 0x05 }, { 0xFE, 0x40, 0x30, 0x40, 0xFE }}, // 0x4D M
   {{ 0x05 }, { 0xFE, 0x40, 0x20, 0x10, 0xFE }}, // 0x4E N
   {{ 0x05 }, { 0x7C, 0x82, 0x82, 0x82, 0x7C }}, // 0x4F O
   {{ 0x05 }, { 0xFE, 0x90, 0x90, 0x90, 0x60 }}, // 0x50 P
   {{ 0x05 }, { 0x7C, 0x82, 0x8A, 0x84, 0x7A }}, // 0x51 Q
   {{ 0x05 }, { 0xFE, 0x90, 0x98, 0x94, 0x62 }}, // 0x52 R
   {{ 0x05 }, { 0x64, 0x92, 0x92, 0x92, 0x4C }}, // 0x53 S
   {{ 0x05 }, { 0x80, 0x80, 0xFE, 0x80, 0x80 }}, // 0x54 T
   {{ 0x05 }, { 0xFC, 0x02, 0x02, 0x02, 0xFC }}, // 0x55 U
   {{ 0x05 }, { 0xF8, 0x04, 0x02, 0x04, 0xF8 }}, // 0x56 V
   {{ 0x05 }, { 0xFC, 0x02, 0x1C, 0x02, 0xFC }}, // 0x57 W
   {{ 0x05 }, { 0xC6, 0x28, 0x10, 0x28, 0xC6 }}, // 0x58 X
   {{ 0x05 }, { 0xE0, 0x10, 0x0E, 0x10, 0xE0 }}, // 0x59 Y
   {{ 0x05 }, { 0x86, 0x8A, 0x92, 0xA2, 0xC2 }}, // 0x5A Z
   {{ 0x03 }, { 0xFE, 0x82, 0x82, 0x00, 0x00 }}, // 0x5B [
   {{ 0x05 }, { 0x40, 0x20, 0x10, 0x08, 0x04 }}, // 0x5C
   {{ 0x03 }, { 0x82, 0x82, 0xFE, 0x00, 0x00 }}, // 0x5D ]
   {{ 0x05 }, { 0x20, 0x40, 0x80, 0x40, 0x20 }}, // 0x5E ^
   {{ 0x05 }, { 0x01, 0x01, 0x01, 0x01, 0x01 }}, // 0x5F _
   {{ 0x02 }, { 0xC0, 0xA0, 0x00, 0x00, 0x00 }}, // 0x60 `
   {{ 0x04 }, { 0x04, 0x2A, 0x2A, 0x1E, 0x00 }}, // 0x61 a
   {{ 0x04 }, { 0xFE, 0x22, 0x22, 0x1C, 0x00 }}, // 0x62 b
   {{ 0x04 }, { 0x1C, 0x22, 0x22, 0x22, 0x00 }}, // 0x63 c
   {{ 0x04 }, { 0x1C, 0x22, 0x22, 0xFE, 0x00 }}, // 0x64 d
   {{ 0x04 }, { 0x1C, 0x2A, 0x2A, 0x18, 0x00 }}, // 0x65 e
   {{ 0x04 }, { 0x10, 0x7E, 0x90, 0x40, 0x00 }}, // 0x66 f
   {{ 0x04 }, { 0x18, 0x25, 0x25, 0x3E, 0x00 }}, // 0x67 g
   {{ 0x04 }, { 0xFE, 0x10, 0x20, 0x1E, 0x00 }}, // 0x68 h
   {{ 0x03 }, { 0x22, 0xBE, 0x02, 0x00, 0x00 }}, // 0x69 i
   {{ 0x04 }, { 0x02, 0x01, 0x21, 0xBE, 0x00 }}, // 0x6A j
   {{ 0x04 }, { 0xFE, 0x08, 0x14, 0x22, 0x00 }}, // 0x6B k
   {{ 0x03 }, { 0x82, 0xFE, 0x02, 0x00, 0x00 }}, // 0x6C l
   {{ 0x05 }, { 0x1E, 0x20, 0x18, 0x20, 0x1E }}, // 0x6D m
   {{ 0x04 }, { 0x3E, 0x10, 0x20, 0x1E, 0x00 }}, // 0x6E n
   {{ 0x04 }, { 0x1C, 0x22, 0x22, 0x1C, 0x00 }}, // 0x6F o
   {{ 0x04 }, { 0x3F, 0x24, 0x24, 0x18, 0x00 }}, // 0x70 p
   {{ 0x04 }, { 0x18, 0x24, 0x24, 0x3F, 0x00 }}, // 0x71 q
   {{ 0x04 }, { 0x3E, 0x10, 0x20, 0x20, 0x00 }}, // 0x72 r
   {{ 0x04 }, { 0x10, 0x2A, 0x2A, 0x04, 0x00 }}, // 0x73 s
   {{ 0x03 }, { 0x20, 0x7E, 0x20, 0x00, 0x00 }}, // 0x74 t
   {{ 0x04 }, { 0x3C, 0x02, 0x02, 0x3C, 0x00 }}, // 0x75 u
   {{ 0x05 }, { 0x38, 0x04, 0x02, 0x04, 0x38 }}, // 0x76 v
   {{ 0x05 }, { 0x3C, 0x02, 0x0C, 0x02, 0x3C }}, // 0x77 w
   {{ 0x05 }, { 0x22, 0x14, 0x08, 0x14, 0x22 }}, // 0x78 x
   {{ 0x05 }, { 0x38, 0x05, 0x05, 0x3E, 0x00 }}, // 0x79 y
   {{ 0x04 }, { 0x26, 0x2A, 0x32, 0x00, 0x00 }}, // 0x7A z
   {{ 0x03 }, { 0x10, 0x6C, 0x82, 0x00, 0x00 }}, // 0x7B {
   {{ 0x01 }, { 0xFF, 0x00, 0x00, 0x00, 0x00 }}, // 0x7C |
   {{ 0x03 }, { 0x82, 0x6C, 0x10, 0x00, 0x00 }}, // 0x7D }
//   {{ 0x04 }, { 0x00, 0x3E, 0x3E, 0x3E, 0x80 }}, // 0x7B user for color icon
//   {{ 0x04 }, { 0x77, 0x41, 0x63, 0x41, 0xF7 }}, // 0x7C end of patter
//   {{ 0x04 }, { 0x14, 0x22, 0x14, 0x22, 0x94 }}  // 0x7D invalid character
#endif
};

#ifdef MEMLIGHT
const char pattern2[] @ 0x1F20 =
#else
const char pattern11[0xdf] @ 0x1F20 =
#endif
       "\xff\xaa\xbb\xcc";

uint8_t user_msg_size;

const uint8_t *patterns[table_count+2] = {
   pattern0,
   pattern1,
   pattern2,
#ifndef MEMLIGHT
   pattern3,
   pattern4,
   pattern5,
   pattern6,
   pattern7,
   pattern8,
   pattern9,
   pattern10,
   pattern11,
#endif
};

const uint16_t pattern_size[table_count+1] = {
   sizeof(pattern0),
   sizeof(pattern1),
   sizeof(pattern2),
#ifndef MEMLIGHT
   sizeof(pattern3),
   sizeof(pattern4),
   sizeof(pattern5),
   sizeof(pattern6),
   sizeof(pattern7),
   sizeof(pattern8),
   sizeof(pattern9),
   sizeof(pattern10),
   sizeof(pattern11)
#endif
}; 

const uint8_t pattern_demo_loops[table_count+1] = {
   15,
   30,
   6,
   25,
   15,
   5,
   4,
   4,
   5,
   80,
   90,
   12
}; 


